/*      
        alph: Piper program implementing and analysing traditional and
        historic c(ai)phers designed to be used in conjuction with other
	     programs.

        Copyright (C) 2004  Corcalciuc V. Horia

        This library is free software; you can redistribute it and/or
        modify it under the terms of the GNU Lesser General Public
        License as published by the Free Software Foundation; either
        version 2.1 of the License, or (at your option) any later version.

        This library is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
        Lesser General Public License for more details.

        You should have received a copy of the GNU Lesser General Public
        License along with this library; if not, write to the Free Software
        Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

*/

#include "alphCRYPT.h"

int
morse(char *org)
{
  int itra, itrb, itrc;
  char *dst;
  char *tmp, *sav;
  
  char *ma[] = { ".-", "-...", "-.-.", "-..", ".",
                 "..-.", "--.", "....", "..", ".---",
                 "-.-", ".-..", "--", "-.", "---", ".--.",
                 "--.-", ".-.", "...", "-", "..-", "...-",
                 ".--", "-..-", "-.--", "--.."};

  char *md[] = { "-----", ".----", "..---", "...--", "....-", ".....",
                 "-....", "--...", "---..", "----.", "----." };

  char *mp[] = { ".-.-.-", "--..--", "---...", "..--..", ".----.",
                 "-....-", "-..-.", "-.--.-", ".-..-.", ".--.-.",
                 "-...-" };

  dst = (char *) calloc(strlen(org)*4, sizeof(char));
  tmp = (char *) calloc(6, sizeof(char));
  
  if(!al_dec)
    for(itra=0; itra<=strlen(org); itra++)
      {
        if(isupper(org[itra]))
          org[itra]=tolower(org[itra]);
        if(isalpha(org[itra]))
          strcat(dst, ma[org[itra]-'a']);
        else if(isdigit(org[itra]))
          strcat(dst, md[org[itra]-'0']);
        else if(ispunct(org[itra]))
          switch(org[itra])
            {
              case '.':
                strcat(dst, mp[0]);
                break;
              case ',':
                strcat(dst, mp[1]);
                break;
              case ';':
                strcat(dst, mp[2]);
                break;
              case '?':
                strcat(dst, mp[3]);
                break;
              case '\'':
                strcat(dst, mp[4]);
                break;
              case '-':
                strcat(dst, mp[5]);
                break;
              case '/':
                strcat(dst, mp[6]);
                break;
              case '(':
              case ')':
                strcat(dst, mp[7]);
                break;
              case '\"':
                strcat(dst, mp[8]);
                break;
              case '@':
                strcat(dst, mp[9]);
                break;
              case '=':
                strcat(dst, mp[10]);
                break;
            }
          strcat(dst, " ");
      }
  else
  {
    for(itra=0, itrb=0, itrc=0; itra<strlen(org); itra++)
      if(!isspace(org[itra]))
        tmp[itrb++]=org[itra];
		else if(isspace(org[itra]) && isspace(org[itra-1]))
				dst[itrc++]=' ';
      else if(isspace(org[itra]) || org[itra]=='\n')
        {
          for(itrb=0; itrb<26; itrb++)
            if(!strcmp(ma[itrb], tmp))
              dst[itrc++]=itrb+97;
          for(itrb=0; itrb<10; itrb++)
            if(!strcmp(md[itrb], tmp))
              dst[itrc++]=itrb+48;
          for(itrb=0; itrb<11; itrb++)
            if(!strcmp(mp[itrb], tmp))
              switch(itrb+48)
              {
                case '0':
                  dst[itrc++]='.';
                  break;
                case '1':
                  dst[itrc++]=',';
                  break;
                case '2':
                  dst[itrc++]=':';
                  break;
                case '3':
                  dst[itrc++]='?';
                  break;
                case '4':
                  dst[itrc++]='\'';
                  break;
                case '5':
                  dst[itrc++]='-';
                  break;
                case '6':
                  dst[itrc++]='/';
                  break;
                case '7':
                  dst[itrc++]='(';
                  break;
                case '8':
                  dst[itrc++]='\"';
                  break;
                case '9':
                  dst[itrc++]='@';
                  break;
                case '\072':
                  dst[itrc++]='=';
                  break;
              }
        	 tmp = (char *) calloc(strlen(tmp), sizeof(char));
          itrb=0;
        }
  }

  if(org[strlen(org)-1]=='\n')
     dst[strlen(dst)]='\n';

  strcpy(org, dst);

  return 0;;
      
}
          
