/*      
        alph: Piper program implementing and analysing traditional and
        historic c(ai)phers designed to be used in conjuction with other
	      programs.

        Copyright (C) 2004  Corcalciuc V. Horia

        This library is free software; you can redistribute it and/or
        modify it under the terms of the GNU Lesser General Public
        License as published by the Free Software Foundation; either
        version 2.1 of the License, or (at your option) any later version.

        This library is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
        Lesser General Public License for more details.

        You should have received a copy of the GNU Lesser General Public
        License along with this library; if not, write to the Free Software
        Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

*/

#include "alphCRYPT.h"

int
playfair (char *org, char *key)
{
  int lph = 'a', pad = 0, sem = 1, itra = 0;
  char *dst, *didst, *fidst, pb[5][5];
  char *n_key;
  char *pnct;

  struct coords
  {
    int x;
    int y;
    int xs;
    int ys;
    int xf;
    int yf;
    int xfs;
    int yfs;
  } *loc;

  if (!strlen (key))
    return KEYB;

  n_key = (char *) calloc (strlen (key), sizeof (char));
  loc = (struct coords *) calloc (1, sizeof (struct coords));

  for (loc->x = 0; loc->x < 5; loc->x++)
    for (loc->y = 0; loc->y < 5; loc->y++)
      pb[loc->x][loc->y]=0;

  for (loc->x = 0, pad = 0; loc->x <= strlen (key); loc->x++)
    {
      if (isupper (key[loc->x]))
	    key[loc->x] = tolower (key[loc->x]);
      if (!strchr (n_key, key[loc->x]))
	    n_key[pad++] = key[loc->x];
    }

  for (loc->y = 0, pad = 0; loc->y < 5 && pad < strlen (n_key); loc->y++)
    for (loc->x = 0; loc->x < 5 && pad < strlen (n_key); loc->x++)
      pb[loc->y][loc->x] = n_key[pad++];

  for (sem = loc->y - 1; lph <= 'z' && loc->y < 6; lph++)
    {
      if (lph == 'q')
	    continue;
      if (loc->x > 4)
	    {
	      loc->x = 0;
	      loc->y++;
	    }
      for (pad = 0; pad <= sem; pad++)
	    if (strchr (pb[pad], lph))
	      break;
      if (pad > sem)
	    pb[loc->y - 1][loc->x++] = lph;
    }

  didst = (char *) calloc (2 * strlen (org), sizeof (char));
  pnct = (char *) calloc (strlen (org), sizeof (char));
  
  for (itra = 0, pad = 0, loc->x = 0; itra < strlen (org); itra++, pad++)
    {
      if (!isalpha (org[itra]) || isspace (org[itra]))
	    pnct[itra] = org[itra];
      else
	    pnct[itra] = 0;
		if(isupper(org[itra]))
		 didst[pad]=tolower(org[itra]);
		else
		 didst[pad]=org[itra];

      loc->x++;
      didst[++pad] = ' ';

    }

  for (pad = 0; pad < strlen (didst); pad += 2)
    {
      if (didst[pad + 2] == didst[pad] && !al_dec)
	{
	  didst[pad + 1] = 'x';
	  loc->x++;
	}
    }

  fidst = (char *) calloc (strlen(didst), sizeof (char));
  for (pad = 0, itra = 0; pad < strlen (didst); pad++)
    if (isalpha (didst[pad]))
      fidst[itra++] = didst[pad];

  dst = (char *) calloc (strlen (org), sizeof (char));
  for (pad = 0, sem = 0, itra = 0; pad <= strlen (org); pad++, sem++)
    {
      for (loc->y = 0; loc->y < 5; loc->y++)
	for (loc->x = 0; loc->x < 5; loc->x++)
	  if (pb[loc->y][loc->x] == fidst[sem])
	    {
	      loc->xs = loc->x;
	      loc->ys = loc->y;
	    }
      for (loc->y = 0; loc->y < 5; loc->y++)
	for (loc->x = 0; loc->x < 5; loc->x++)
	  if (pb[loc->y][loc->x] == fidst[sem + 1])
	    {
	      if (loc->ys == loc->y)
		{
		  if (loc->xs + 1 > 4)
		    loc->xfs = 0;
		  else
		    {
		      if (!al_dec)
			loc->xfs = loc->xs + 1;
		      else if (loc->xs - 1 < 0)
			loc->xfs = 4;
		      else
			loc->xfs = loc->xs - 1;
		    }
		  if (loc->x + 1 > 4)
		    loc->xf = 0;
		  else
		    {
		      if (!al_dec)
			loc->xf = loc->x + 1;
		      else if (loc->x - 1 < 0)
			loc->xf = 4;
		      else
			loc->xf = loc->x - 1;
		    }
		  dst[itra++] = pb[loc->y][loc->xfs];
		  dst[itra++] = pb[loc->y][loc->xf];
		}
	      if (loc->xs == loc->x)
		{
		  if (loc->ys + 1 > 4)
		    loc->yfs = 0;
		  else
		    {
		      if (!al_dec)
			loc->yfs = loc->ys + 1;
		      else if (loc->ys - 1 < 0)
			loc->yfs = 4;
		      else
			loc->yfs = loc->ys - 1;
		    }
		  if (loc->y + 1 > 4)
		    loc->yf = 0;
		  else
		    {
		      if (!al_dec)
			loc->yf = loc->y + 1;
		      else if (loc->y - 1 < 0)
			loc->yf = 4;
		      else
			loc->yf = loc->y - 1;
		    }
		  dst[itra++] = pb[loc->yfs][loc->x];
		  dst[itra++] = pb[loc->yf][loc->x];
		}
	      if (loc->xs != loc->x && loc->ys != loc->y)
		{
		  if (loc->xs > loc->x)
		    {
		      loc->xf = loc->x;
		      loc->yf = loc->ys;
		      loc->xfs = loc->xs;
		      loc->yfs = loc->y;
		    }
		  else if (loc->xs < loc->x)
		    {
		      loc->xf = loc->x;
		      loc->yf = loc->ys;
		      loc->xfs = loc->xs;
		      loc->yfs = loc->y;
		    }
		  else if (loc->xs == loc->y)
		    {
		      loc->xfs = loc->xs;
		      loc->yfs = loc->y;
		      loc->xf = loc->x;
		      loc->yf = loc->ys;
		    }
		  else
		    return UNKN;
		  dst[itra++] = pb[loc->yf][loc->xf];
		  dst[itra++] = pb[loc->yfs][loc->xfs];
		}
	    }
      sem++;
    }

  didst = (char *) calloc (2 * strlen (org), sizeof (char));
  for (itra = 0, pad = 0; itra < strlen (org); itra++)
    {
      if (pnct[itra] != 0)
	didst[itra] = pnct[itra];
      else if(isupper(org[itra]))
	didst[itra] = toupper(dst[pad++]);
		else
	didst[itra] = dst[pad++];
    }

  dst = (char *) calloc (strlen (org), sizeof (char));
  strcpy (dst, didst);

  strncpy (org, dst, strlen (dst));

  return 0;
}
